package com.dev.lavin.bcard

import android.support.multidex.MultiDexApplication
import com.dev.lavin.bcard.di.application.AppComponent
import com.dev.lavin.bcard.di.application.AppModule
import com.dev.lavin.bcard.di.application.DaggerAppComponent

/**
 * Created by lavin
 * on 15/04/2018.
 */
class BcardApp : MultiDexApplication() {

    private var mBcardAppAppComponent: AppComponent? = null

    val component: AppComponent?
        get() = app?.mBcardAppAppComponent

    /**
     * Called when the application is starting, before any activity, service,
     * or receiver objects (excluding content providers) have been created.
     * Implementations should be as quick as possible (for example using
     * lazy initialization of state) since the time spent in this function
     * directly impacts the performance of starting the first activity,
     * service, or receiver in a process.
     * If you override this method, be sure to call super.onCreate().
     */
    override fun onCreate() {
        super.onCreate()
        initDI()
        app = this
    }

    fun initDI() {
        mBcardAppAppComponent = DaggerAppComponent.builder()
                .appModule(AppModule(this)).build()
        // Inject App inside DI Graph
        mBcardAppAppComponent!!.inject(this)
    }

    companion object {
        private var app: BcardApp? = null
    }

}
