package com.dev.lavin.bcard.adapters

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.dev.lavin.bcard.R
import com.dev.lavin.domain2.model.Device
import kotlinx.android.synthetic.main.device_name.view.*

/**
 * Created by lavin
 * on 20/04/2018.
 */
class DeviceListAdapter(var deviceList: List<Device>, private val mListener: DeviceListAdapter.OnDeviceSelectedListener) : RecyclerView.Adapter<DeviceListAdapter.ViewHolder>() {

    interface OnDeviceSelectedListener {
        fun onDeviceSelected(device: Device)
    }

    var context: Context? = null

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(parent.context).inflate(R.layout.device_name, parent, false)
        context = parent.context
        return ViewHolder(view)
    }

    override fun onBindViewHolder(holder: DeviceListAdapter.ViewHolder, position: Int) {
        holder.bind(deviceList[position], mListener)
    }

    override fun getItemCount(): Int {
        return deviceList.size
    }

    inner class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {

        fun bind(device: Device,
                 listener: DeviceListAdapter.OnDeviceSelectedListener?) {

            if (device.name != null) {
                if(device.name!!.isEmpty()){
                    itemView.deviceName.text = "Unknown device name"
                }else {
                    itemView.deviceName.text = device.name
                }
            }
            if (device.addres != null) {
                itemView.deviceAddress.text = device.addres
            }
            // Click listener
            itemView.setOnClickListener {
                if (listener != null) {
                    listener!!.onDeviceSelected(device)
                }
            }
        }
    }

}