package com.dev.lavin.bcard.base

import android.os.Bundle
import android.support.v7.app.AppCompatActivity

import com.dev.lavin.bcard.BcardApp
import com.dev.lavin.bcard.di.application.AppComponent


abstract class BaseActivity<T> : AppCompatActivity() {

    var activityComponent: T? = null
    get() {
       if(field == null){
           initDI()
       }
        return field
    }

    val appComponent: AppComponent?
        get() = (application as BcardApp).component

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        initDI()
    }

    protected abstract fun initDI()

    fun setActionBarTitle(title: String) {
        supportActionBar!!.title = title
    }
}
