package com.dev.lavin.bcard.di.activity

import com.dev.lavin.bcard.di.fragment.BaseFragmentComponent
import com.dev.lavin.bcard.di.fragment.BaseFragmentModule
import com.dev.lavin.bcard.di.presenter.BasePresenterComponent
import com.dev.lavin.bcard.di.presenter.BasePresenterModule
import com.dev.lavin.bcard.di.scopes.PerActivity
import com.dev.lavin.bcard.login.LoginActivity
import com.dev.lavin.bcard.main.MainActivity
import com.dev.lavin.bcard.main.cards.create.CardCreateActivity
import com.dev.lavin.bcard.main.cards.detail.CardDetailActivity
import com.dev.lavin.bcard.main.cards.edit.EditCardActivity
import com.dev.lavin.bcard.main.events.cardadd.EventCardAddActivity
import com.dev.lavin.bcard.main.events.create.NewEventActivity
import com.dev.lavin.bcard.main.events.detail.EventDetailActivity
import com.dev.lavin.bcard.main.events.edit.EditEventActivity
import com.dev.lavin.bcard.register.RegisterActivity
import com.dev.lavin.bcard.resetpassword.ResetPasswordActivity
import dagger.Subcomponent

@PerActivity
@Subcomponent(modules = [(ActivityModule::class)])
interface ActivityComponent {

    fun injectActivity(mainActivity: MainActivity)

    fun injectActivity(loginActivity: LoginActivity)

    fun injectActivity(registerActivity: RegisterActivity)

    fun injectActivity(resetPasswordActivity: ResetPasswordActivity)

    fun injectActivity(eventDetailActivity: EventDetailActivity)

    fun injectActivity(cardDetailActivity: CardDetailActivity)

    fun injectActivity(newEventActivity: NewEventActivity)

    fun injectActivity(eventCardAddActivity: EventCardAddActivity)

    fun injectActivity(cardCreateActivity: CardCreateActivity)

    fun injectActivity(editEventActivity: EditEventActivity)

    fun injectActivity(editCardActivity: EditCardActivity)

    fun with(baseFragmentModule: BaseFragmentModule): BaseFragmentComponent

    fun with(basePresenterModule: BasePresenterModule): BasePresenterComponent
}
