package com.dev.lavin.bcard.di.application

import android.app.Application
import android.content.res.Resources
import com.dev.lavin.bcard.BcardApp
import com.dev.lavin.bcard.di.activity.ActivityComponent
import com.dev.lavin.bcard.di.activity.ActivityModule
import dagger.Component
import javax.inject.Singleton

@Singleton
@Component(modules = [(AppModule::class)])
interface AppComponent {

    /**
     * Here we can provide an App-Scoped Singleton with following method
     */
    fun inject(bcardApp: BcardApp)

    fun with(mainActivityModule: ActivityModule): ActivityComponent

    fun application(): Application

    fun resources(): Resources

}
