package com.dev.lavin.bcard.di.application

import android.app.Application
import android.content.res.Resources
import com.dev.lavin.bcard.BcardApp
import com.dev.lavin.domain2.model.Contacts
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.firestore.FirebaseFirestore
import com.google.firebase.storage.FirebaseStorage
import dagger.Module
import dagger.Provides
import javax.inject.Singleton

@Module
class AppModule(private val mApplication: BcardApp) {

    @Provides
    @Singleton
    fun provideApplication(): Application {
        return this.mApplication
    }

    @Provides
    @Singleton
    fun providesResources(): Resources = this.mApplication.resources

    @Provides
    @Singleton
    fun provideFirebaseAuth(): FirebaseAuth {
        return FirebaseAuth.getInstance()
    }

    @Provides
    @Singleton
    fun provideFirebaseFirestore(): FirebaseFirestore {
        return FirebaseFirestore.getInstance()
    }

    @Provides
    @Singleton
    fun provideFirebaseStorage(): FirebaseStorage {
        return FirebaseStorage.getInstance()
    }

    @Provides
    @Singleton
    fun provideContacts(): Contacts {
        return Contacts()
    }

}
