package com.dev.lavin.bcard.di.fragment

import com.dev.lavin.bcard.di.presenter.BasePresenterComponent
import com.dev.lavin.bcard.di.presenter.BasePresenterModule
import com.dev.lavin.bcard.di.scopes.PerFragment
import com.dev.lavin.bcard.main.events.EventsFragment
import com.dev.lavin.bcard.main.contacts.ContactsFragment
import com.dev.lavin.bcard.main.profile.ProfileFragment
import dagger.Subcomponent


@PerFragment
@Subcomponent(modules = [(BaseFragmentModule::class)])
interface BaseFragmentComponent {

    fun inject(homeFragment: ContactsFragment)

    fun inject(profileFragment: ProfileFragment)

    fun inject(eventsFragment: EventsFragment)

    fun with(basePresenterModule: BasePresenterModule): BasePresenterComponent

}
