package com.dev.lavin.bcard.di.fragment

import android.app.Activity
import com.dev.lavin.bcard.base.BaseFragmentView
import com.dev.lavin.bcard.di.presenter.BasePresenterModule
import com.dev.lavin.bcard.di.scopes.PerFragment
import com.dev.lavin.bcard.main.events.EventsPresenter
import com.dev.lavin.bcard.main.events.EventsPresenterImpl
import com.dev.lavin.bcard.main.events.EventsView
import com.dev.lavin.bcard.main.contacts.ContactsPresenter
import com.dev.lavin.bcard.main.contacts.ContactsPresenterImpl
import com.dev.lavin.bcard.main.contacts.ContactsView
import com.dev.lavin.bcard.main.profile.ProfilePresenter
import com.dev.lavin.bcard.main.profile.ProfilePresenterImpl
import com.dev.lavin.bcard.main.profile.ProfileView
import dagger.Module
import dagger.Provides


@Module
class BaseFragmentModule(private val baseView: BaseFragmentView, private val activity: Activity) {

    @PerFragment
    @Provides
    fun provideBaseInjectionFragment(): BaseFragmentView {
        return baseView
    }

    @PerFragment
    @Provides
    fun provideEventsPresenter(baseFragmentComponent: BaseFragmentComponent): EventsPresenter {
        return EventsPresenterImpl(baseView as EventsView, baseFragmentComponent.with(BasePresenterModule(activity)))
    }

    @PerFragment
    @Provides
    fun provideHomePresenter(baseFragmentComponent: BaseFragmentComponent): ContactsPresenter {
        return ContactsPresenterImpl(baseView as ContactsView, baseFragmentComponent.with(BasePresenterModule(activity)))
    }

    @PerFragment
    @Provides
    fun provideProfilePresenter(baseFragmentComponent: BaseFragmentComponent): ProfilePresenter {
        return ProfilePresenterImpl(baseView as ProfileView, baseFragmentComponent.with(BasePresenterModule(activity)))
    }
}
