package com.dev.lavin.bcard.di.presenter

import com.dev.lavin.bcard.di.scopes.PerPresenter
import com.dev.lavin.bcard.login.LoginPresenterImpl
import com.dev.lavin.bcard.main.MainActivityPresenterImpl
import com.dev.lavin.bcard.main.cards.create.CardCreatePresenterImpl
import com.dev.lavin.bcard.main.cards.detail.CardDetailPresenterImpl
import com.dev.lavin.bcard.main.cards.edit.EditCardPresenterImpl
import com.dev.lavin.bcard.main.contacts.ContactsPresenterImpl
import com.dev.lavin.bcard.main.events.EventsPresenterImpl
import com.dev.lavin.bcard.main.events.cardadd.EventCardAddPresenterImpl
import com.dev.lavin.bcard.main.events.create.NewEventPresenterImpl
import com.dev.lavin.bcard.main.events.detail.EventsDetailPresenterImpl
import com.dev.lavin.bcard.main.events.edit.EditEventPresenterImpl
import com.dev.lavin.bcard.main.profile.ProfilePresenterImpl
import com.dev.lavin.bcard.register.RegisterPresenterImpl
import com.dev.lavin.bcard.resetpassword.ResetPasswordPresenterImpl
import com.dev.lavin.data.di.BaseRepositoryComponent
import com.dev.lavin.data.di.BaseRepositoryModule
import com.dev.lavin.domain2.di.BaseInteractorComponent
import com.dev.lavin.domain2.di.BaseInteractorModule
import dagger.Subcomponent


@PerPresenter
@Subcomponent(modules = [(BasePresenterModule::class)])
interface BasePresenterComponent {

    fun injectPresenter(loginPresenter: LoginPresenterImpl)

    fun injectPresenter(registerPresenter: RegisterPresenterImpl)

    fun injectPresenter(mainActivityPresenterImpl: MainActivityPresenterImpl)

    fun injectPresenter(homePresenterImpl: ContactsPresenterImpl)

    fun injectPresenter(eventsPresenterImpl: EventsPresenterImpl)

    fun injectPresenter(profilePresenterImpl: ProfilePresenterImpl)

    fun injectPresenter(cardDetailPresenterImpl: CardDetailPresenterImpl)

    fun injectPresenter(newEventPresenterImpl: NewEventPresenterImpl)

    fun injectPresenter(eventCardAddPresenterImpl: EventCardAddPresenterImpl)

    fun injectPresenter(eventsDetailPresenterImpl: EventsDetailPresenterImpl)

    fun injectPresenter(cardCreatePresenterImpl: CardCreatePresenterImpl)

    fun injectPresenter(resetPasswordPresenterImpl: ResetPasswordPresenterImpl)

    fun injectPresenter(editEventPresenterImpl: EditEventPresenterImpl)

    fun injectPresenter(editCardPresenterImpl: EditCardPresenterImpl)
    //interactor providers
    fun with(baseInteractorModule: BaseInteractorModule): BaseInteractorComponent

    //repo providers
    fun with(baseRepositoryModule: BaseRepositoryModule): BaseRepositoryComponent
}
