package com.dev.lavin.bcard.links

import android.content.Intent
import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import android.util.Log
import com.dev.lavin.bcard.main.MainActivity
import com.google.android.gms.common.ConnectionResult
import com.google.android.gms.common.api.GoogleApiClient
import com.google.android.gms.tasks.OnSuccessListener
import com.google.firebase.dynamiclinks.FirebaseDynamicLinks


/**
 * Created by lavin
 * on 30/05/2017.
 */

class DynamicLinksActivity : AppCompatActivity(), GoogleApiClient.OnConnectionFailedListener {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        FirebaseDynamicLinks.getInstance().getDynamicLink(intent)
                .addOnSuccessListener(this, OnSuccessListener { data ->
                    if (data == null) {
                        Log.d("DynamicLinksActivity", "getInvitation: no deep link found.")
                        return@OnSuccessListener
                    }

                    // Get the deep link
                    val deepLink = data.link
                    // Handle the deep link
                    Log.d("DynamicLinksActivity", "deepLink:" + deepLink!!)
                    if (deepLink != null) {
                        val id = deepLink.getQueryParameter("id")
                        if (id != null) {
                            val i = Intent(this@DynamicLinksActivity, MainActivity::class.java)
                            i.putExtra("EventId", id)
                            startActivity(i)
                            finish()
                        } else {
                            val i = Intent(this@DynamicLinksActivity, MainActivity::class.java)
                            startActivity(i)
                            finish()
                        }
                    } else {
                        Log.d("DynamicLinksActivity", "getInvitation: no deep link found.")
                    }
                })
                .addOnFailureListener(this) { Log.d("DynamicLinksActivity", "getDynamicLink:onFailure") }
    }

    override fun onConnectionFailed(connectionResult: ConnectionResult) {

    }
}
