package com.dev.lavin.bcard.login

import android.text.TextUtils
import com.dev.lavin.bcard.base.BasePresenterImpl
import com.dev.lavin.bcard.di.presenter.BasePresenterComponent
import com.dev.lavin.domain2.interactors.login.LoginInteractor
import javax.inject.Inject

/**
 * Created by lavin
 * on 16/04/2018.
 */
class LoginPresenterImpl(loginView: LoginView, basePresenterComponent: BasePresenterComponent) : BasePresenterImpl<LoginView>(loginView),  LoginPresenter,  LoginInteractor.LoginInteractorResponse  {

    @Inject
    lateinit var loginInteractor: LoginInteractor

    init {
        view = loginView
        basePresenterComponent.injectPresenter(this)
    }

    override fun tryLogin(user: String?, pass: String?) {
        if (user!=null && !TextUtils.isEmpty(user)&& pass != null && !TextUtils.isEmpty(pass)) {
            view?.hideKeyboard()
            view?.showLoading()
            loginInteractor.login(user, pass, this)
        } else {
            view?.showInvalidFieldsError()
        }
    }

    override fun onLoginInteractorResponseSuccess() {
        view?.hideLoading()
        view?.sendToMain()
    }

    override fun onLoginInteractorResponseFailureAuth(message: String) {
        view?.hideLoading()
        if(message != null) {
            view?.showServiceError(message)
        }else{
            view?.showGenericError()
        }
    }


}