package com.dev.lavin.bcard.main

import com.dev.lavin.bcard.base.BasePresenterImpl
import com.dev.lavin.bcard.di.presenter.BasePresenterComponent
import com.dev.lavin.domain2.interactors.cards.CardsInteractor
import javax.inject.Inject

/**
 * Created by lavin
 * on 16/04/2018.
 */
class MainActivityPresenterImpl(mainActivityView: MainActivityView, basePresenterComponent: BasePresenterComponent) : BasePresenterImpl<MainActivityView>(mainActivityView), MainActivityPresenter, CardsInteractor.CardsContactsAddInteractorResponse {

    @Inject
    lateinit var cardsInteractor: CardsInteractor

    init {
        view = mainActivityView
        basePresenterComponent.injectPresenter(this)
    }

    override fun addCardToContacts(idCard: String?, idUser: String?) {
        if (idCard != null && idUser != null) {
            view?.showAddLoading()
            cardsInteractor.addCardToContacts(idCard, idUser, this)
        }
    }

    override fun onCardsContactsAddInteractorResponseSuccess() {
        view?.hideAddLoading()
        view?.onCardAdded()
    }

    override fun onCardsContactsAddInteractorResponseFailure(message: String) {
        view?.hideAddLoading()
        view?.showError(message)
    }
}