package com.dev.lavin.bcard.main.cards.detail

import com.dev.lavin.bcard.base.BasePresenterImpl
import com.dev.lavin.bcard.di.presenter.BasePresenterComponent
import com.dev.lavin.domain2.interactors.cards.CardsInteractor
import com.dev.lavin.domain2.model.Card
import javax.inject.Inject

/**
 * Created by lavin
 * on 16/04/2018.
 */
class CardDetailPresenterImpl(cardDetailView: CardDetailView, basePresenterComponent: BasePresenterComponent) : BasePresenterImpl<CardDetailView>(cardDetailView), CardDetailPresenter, CardsInteractor.CardsContactsAddInteractorResponse {

    @Inject
    lateinit var cardsInteractor: CardsInteractor

    init {
        view = cardDetailView
        basePresenterComponent.injectPresenter(this)
    }

    override fun presentInfo(card: Card) {
        view?.setCardInfo(card)
    }

    override fun addCardToContacts(idCard: String?, idUser: String?) {
        if (idCard != null && idUser != null) {
            view?.showLoading()
            cardsInteractor.addCardToContacts(idCard, idUser, this)
        }
    }

    override fun onCardsContactsAddInteractorResponseFailure(message: String) {
        view?.hideLoading()
        view?.setError(message)
    }

    override fun onCardsContactsAddInteractorResponseSuccess() {
        view?.hideLoading()
        view?.onCardAdded()
    }

}