package com.dev.lavin.bcard.main.events.cardadd

import com.dev.lavin.bcard.base.BasePresenterImpl
import com.dev.lavin.bcard.di.presenter.BasePresenterComponent
import com.dev.lavin.bcard.utils.CardUtils
import com.dev.lavin.domain2.interactors.cards.CardsInteractor
import com.dev.lavin.domain2.model.Card
import java.util.*
import javax.inject.Inject

/**
 * Created by lavin
 * on 16/04/2018.
 */
class EventCardAddPresenterImpl(eventCardAddView: EventCardAddView, basePresenterComponent: BasePresenterComponent) : BasePresenterImpl<EventCardAddView>(eventCardAddView), EventCardAddPresenter, CardsInteractor.CardsFromUserInteractorResponse, CardsInteractor.CardsSetInEventInteractorResponse {

    @Inject
    lateinit var cardsInteractor: CardsInteractor

    private var cardListEventFragment: MutableList<Card>? = ArrayList()

    init {
        view = eventCardAddView
        basePresenterComponent.injectPresenter(this)
    }

    override fun getUserCards(id: String) {
        cardsInteractor.getUserCards(id, this)
    }

    override fun onCardsFromUserInteractorResponseSuccess(cardList: MutableMap<String, MutableList<Card>>) {
        CardUtils.addCards(cardList, cardListEventFragment)
        CardUtils.modifyCards(cardList, cardListEventFragment)
        view?.setCardEventList(cardListEventFragment!!)
    }


    override fun addCard(idEvent: String, idCard: String) {
        view?.showLoading()
        cardsInteractor.setCardInEvent(idEvent, idCard, this)
    }

    override fun onCardsFromUserInteractorResponseFailure(message: String) {
        view?.hideLoading()
        view?.setErrorService(message)
    }

    override fun onCardsSetInEventInteractorResponseSuccess() {
        view?.hideLoading()
        view?.onCardAdded()
    }

    override fun onCardsFromUserEmpty() {
        view?.hideLoading()
        view?.setEmpty()
    }

    override fun onCardsSetInEventInteractorResponseFailure(message: String) {
        view?.hideLoading()
        view?.setErrorService(message)
    }

}