package com.dev.lavin.bcard.utils

import android.content.Context
import android.net.ConnectivityManager
import android.net.NetworkInfo

/**
 * Created by lavin
 * on 22/04/2018.
 */
object InternetUtils {

    fun checkInternetConnection(ctx: Context): Boolean {
        val conn = ctx
                .getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
        val activeNetworkInfo: NetworkInfo? = conn.activeNetworkInfo
        /* No Internet? Show dialog and Intent to system's settings */
        return activeNetworkInfo != null && activeNetworkInfo.isConnected
    }

    fun isNetworkAvailable(context: Context): Boolean {
        val connectivityManager = context.getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
        return connectivityManager.activeNetworkInfo != null && connectivityManager.activeNetworkInfo.isConnected
    }
}
