package com.dev.lavin.bcard.utils

import java.text.SimpleDateFormat
import java.util.*
import java.util.concurrent.TimeUnit

/**
 * Created by lavin
 * on 23/03/2018.
 */

object TimeUtils {

    fun today(): String {
        val dateFormat = SimpleDateFormat("dd/MM/yyyy")
        val today = Date()
        return dateFormat.format(today)
    }

    fun timefromMilliseconds(milliseconds: Long): String {
        val dateFormat = SimpleDateFormat("HH:mm:ss")
        val date = Calendar.getInstance()
        date.timeInMillis = milliseconds
        return dateFormat.format(date.timeInMillis)
    }

    fun datefromMilliseconds(milliseconds: Long): String {
        val dateFormat = SimpleDateFormat("dd/MM/yyyy")
        val date = Calendar.getInstance()
        date.timeInMillis = milliseconds
        return dateFormat.format(date.timeInMillis)
    }

    fun todayInMilliseconds(): Long {
        val today = Date()
        val date = Calendar.getInstance()
        date.timeInMillis = today.time
        return date.timeInMillis
    }

    fun todayInSeconds(): Long {
        val today = Date()
        val date = Calendar.getInstance()
        date.timeInMillis = today.time
        return date.timeInMillis / 1000
    }

    fun todayInMillisecondsPlusSeconds(secondsToAdd: Int): Long {
        val today = Date()
        val date = Calendar.getInstance()
        date.timeInMillis = today.time
        date.add(Calendar.SECOND, secondsToAdd)
        return date.timeInMillis
    }

    fun todayMinusDays(daysToSubstract: Int): Long {
        val today = Date()
        val date = Calendar.getInstance()
        date.timeInMillis = today.time
        date.add(Calendar.DAY_OF_MONTH, -daysToSubstract)
        return date.timeInMillis
    }

    fun todayMinusMonths(monthsToSubstract: Int): Long {
        val today = Date()
        val date = Calendar.getInstance()
        date.timeInMillis = today.time
        date.add(Calendar.MONTH, -monthsToSubstract)
        return date.timeInMillis
    }

    fun todayPlusMonths(monthsToAdd: Int): Long {
        val today = Date()
        val date = Calendar.getInstance()
        date.timeInMillis = today.time
        date.add(Calendar.MONTH, monthsToAdd)
        return date.timeInMillis
    }

    fun timeInSecondsPlusMinutes(date: Date, minutesToAdd: Int): Long {
        val datePlusMinutes = Calendar.getInstance()
        datePlusMinutes.timeInMillis = date.time
        datePlusMinutes.add(Calendar.MINUTE, minutesToAdd)
        return datePlusMinutes.timeInMillis / 1000
    }

    fun todayPlusMonthsDifferenceInDays(date: Long, monthsToAdd: Int): Long {
        val today = Date()
        val end = Calendar.getInstance()
        end.timeInMillis = date
        end.add(Calendar.MONTH, monthsToAdd)
        val difference = end.timeInMillis - today.time
        return TimeUnit.DAYS.convert(difference, TimeUnit.MILLISECONDS)
    }

    fun millisecondsfromFormatDMY(dateToFormat: String): Long {
        return try {
            val day = Integer.parseInt(dateToFormat.substring(0, 2))
            val month = Integer.parseInt(dateToFormat.substring(3, 5))
            val year = Integer.parseInt(dateToFormat.substring(6, 10))
            val dateToFormatConverted = GregorianCalendar(year, month - 1, day)
            dateToFormatConverted.timeInMillis
        } catch (e: IndexOutOfBoundsException) {
            0
        }

    }
}
