package com.dev.lavin.domain2.boundaries

import android.net.Uri
import com.dev.lavin.domain2.model.Event


/**
 * Created by Jorge Lavin on 16/04/18.
 */

interface EventsRepoInterface {

    fun getEvents(eventsResponseListener: EventsRepoInterface.EventsResponseListener)

    fun getEventDetail(id: String, eventDetailResponseListener: EventsRepoInterface.EventDetailResponseListener)

    fun createEvent(name: String, date: Long, time: String, location: String, category: String, description: String, url: Uri, eventsCreateResponseListener: EventsRepoInterface.EventsCreateResponseListener)

    fun editEvent(id: String, name: String, date: Long, time: String, location: String, category: String, description: String, url: Uri?, eventsEditResponseListener: EventsRepoInterface.EventsEditResponseListener)

    interface EventsResponseListener {

        fun onEventsSuccesResponse(event: MutableMap<String, MutableList<Event>>)

        fun onEventsFailure(message: String)

        fun onEventsEmptyResponse()
    }

    interface EventDetailResponseListener {

        fun onEventDetailSuccesResponse(event: Event)

        fun onEventDetaiFailure(message: String)

        fun onEventNotExistResponse()
    }

    interface EventsCreateResponseListener {

        fun onEventsCreateSuccesResponse()

        fun onEventsCreateFailure(message: String)
    }

    interface EventsEditResponseListener {

        fun onEventsEditSuccesResponse(eventMap: MutableMap<String, Any>)

        fun onEventsEditFailure(message: String)
    }

}
