package com.dev.lavin.domain2.di


import com.dev.lavin.domain2.di.scopes.PerInteractor
import com.dev.lavin.domain2.interactors.cards.CardsInteractorImpl
import com.dev.lavin.domain2.interactors.events.EventsInteractorImpl
import com.dev.lavin.domain2.interactors.login.LoginInteractorImpl
import com.dev.lavin.domain2.interactors.profile.ProfileInteractorImpl
import com.dev.lavin.domain2.interactors.register.RegisterInteractorImpl
import com.dev.lavin.domain2.interactors.resetpassword.ResetPasswordInteractorImpl
import dagger.Subcomponent

@PerInteractor
@Subcomponent(modules = [(BaseInteractorModule::class)])
interface BaseInteractorComponent {

    fun inject(loginInteractor: LoginInteractorImpl)

    fun inject(registerInteractor: RegisterInteractorImpl)

    fun inject(profileInteractor: ProfileInteractorImpl)

    fun inject(cardsInteractor: CardsInteractorImpl)

    fun inject(eventsInteractor: EventsInteractorImpl)

    fun inject(resetPasswordInteractor: ResetPasswordInteractorImpl)
}
