package com.dev.lavin.domain2.interactors.cards

import android.net.Uri
import com.dev.lavin.domain2.model.Card

/**
 * Created by Jorge Lavin on 16/04/18.
 */

interface CardsInteractor {

    fun getCards(cardsInteractorResponse: CardsInteractorResponse)

    fun getContactCards(id: String, cardsContactInteractorResponse: CardsContactInteractorResponse)

    fun getUserCards(id: String, cardsFromUserInteractorResponse: CardsFromUserInteractorResponse)

    fun getCardsFromEvent(key: String, cardFromEventInteractorResponse: CardFromEventInteractorResponse)

    fun setCardInEvent(idEvent: String, idCard: String, cardsSetInEventInteractorResponse: CardsSetInEventInteractorResponse)

    fun createCard(name: String, company: String, position: String, email: String, phone: String, web: String, notes: String, profile: Uri?, caption: Uri?, createCardsInteractorResponse: CreateCardsInteractorResponse)

    fun addCardToContacts(idCard: String, idUser: String, cardsContactsAddInteractorResponse: CardsContactsAddInteractorResponse)

    fun editCard(id: String,name: String, company: String, position: String, email: String, phone: String, web: String, notes: String, profile: Uri?, caption: Uri?, cardEditInteractorResponse: CardEditInteractorResponse)

    interface CardsInteractorResponse {

        fun onCardsInteractorResponseSuccess(cardList: MutableMap<String, MutableList<Card>>)

        fun onCardsInteractorResponseFailure(message: String)
    }

    interface CardsContactInteractorResponse {

        fun onCardsContactInteractorResponseSuccess(cardList: MutableMap<String, MutableList<Card>>)

        fun onCardsContactInteractorResponseFailure(message: String)
    }

    interface CardsFromUserInteractorResponse {

        fun onCardsFromUserInteractorResponseSuccess(cardList: MutableMap<String, MutableList<Card>>)

        fun onCardsFromUserInteractorResponseFailure(message: String)

        fun onCardsFromUserEmpty()
    }

    interface CardFromEventInteractorResponse {

        fun onCardFromEventInteractorResponseSuccess(cardList: MutableMap<String, MutableList<Card>>)

        fun onCardFromEventInteractorResponseFailure(message: String)

        fun onCardsFromEventEmpty()
    }

    interface CardsSetInEventInteractorResponse {

        fun onCardsSetInEventInteractorResponseSuccess()

        fun onCardsSetInEventInteractorResponseFailure(message: String)
    }

    interface CreateCardsInteractorResponse {

        fun onCreateCardsInteractorResponseSuccess()

        fun onCreateCardsInteractorResponseFailure(message: String)
    }

    interface CardsContactsAddInteractorResponse {

        fun onCardsContactsAddInteractorResponseSuccess()

        fun onCardsContactsAddInteractorResponseFailure(message: String)
    }

    interface CardEditInteractorResponse {

        fun onCardEditInteractorResponseSuccess(cardMap: MutableMap<String, Any>)

        fun onCardEditInteractorResponseFailure(message: String)
    }
}
