package com.dev.lavin.domain2.interactors.events

import android.net.Uri
import com.dev.lavin.domain2.model.Event

/**
 * Created by Jorge Lavin on 16/04/18.
 */

interface EventsInteractor {

    fun getEvents(eventsInteractorResponse: EventsInteractor.EventsInteractorResponse)

    fun getEventDetail(id: String, eventDetailInteractorResponse: EventsInteractor.EventDetailInteractorResponse)

    fun createEvent(name: String, date: Long, time: String, location: String, category: String, description: String, url: Uri, eventsCreateInteractorResponse: EventsInteractor.EventsCreateInteractorResponse)

    fun editEvent(id: String, name: String, date: Long, time: String, location: String, category: String, description: String, url: Uri?, eventsEditInteractorResponse: EventsInteractor.EventsEditInteractorResponse)


    interface EventsInteractorResponse {

        fun onEventsInteractorResponseSuccess(eventList: MutableMap<String, MutableList<Event>>)

        fun onEventsInteractorResponseFailure(message: String)

        fun onEventsEmptyInteractorResponse()
    }

    interface EventDetailInteractorResponse {

        fun onEventDetailInteractorResponseSuccess(event: Event)

        fun onEventDetailInteractorResponseFailure(message: String)

        fun onEventNotExistInteractorResponse()
    }

    interface EventsCreateInteractorResponse {

        fun onEventsCreateInteractorResponseSuccess()

        fun onEventsCreateInteractorResponseFailure(message: String)
    }

    interface EventsEditInteractorResponse {

        fun onEventsEditInteractorResponseSuccess(eventMap: MutableMap<String, Any>)

        fun onEventsEditInteractorResponseFailure(message: String)
    }
}
